
/**
 * Copyright (c) Milad Eftekhar <milad@cs.toronto.edu>
 * @author Milad
 *
 */

import java.io.*;
import java.util.ArrayList;
import java.util.Hashtable;

public class readFile {

	public static ArrayList<weightedEdge>[] weightarr(String input) throws IOException{
		int NodeNum = 1207074;
		ArrayList<weightedEdge>[] InputGraph = new ArrayList[NodeNum];
		for(int i =0; i<NodeNum;i++)
			InputGraph[i] = new ArrayList<weightedEdge>();
		BufferedReader file = new BufferedReader(new FileReader(input));
		String line = file.readLine();
	//	int lineNo=1;
		while(line != null){
		//	if(lineNo%1000000 == 0) System.out.println(lineNo);
			String[] edge = line.split(",");
			int caller = Integer.parseInt(edge[0]);
			int callee = Integer.parseInt(edge[1]);
			int num = Integer.parseInt(edge[2]);
			float totaltime = Float.parseFloat(edge[3]);
			float weight = (float)(totaltime/num);						//we need a good weight function
			int index1 = FindIndex(InputGraph[caller], callee);
			if(index1 == -1){
				InputGraph[caller].add(new weightedEdge(callee,weight,0));
			}else{
				InputGraph[caller].get(index1).setWeight(weight);
			}
			int index2 = FindIndex(InputGraph[callee], caller);
			if(index2 !=-1){
				InputGraph[callee].get(index2).setRWeight(weight);
			}
			else{
				InputGraph[callee].add(new weightedEdge(caller, 0, weight));
			}
			line = file.readLine(); //lineNo++;
		}
		file.close();
		
		//Normalize Weights: Sum of reverse weights for each node (In-edges) should be equal to one.
		for (int i=0; i<NodeNum; i++){
			float sum = 0;
			int size_i = InputGraph[i].size();
			for (int j=0; j<size_i;j++){
				sum += InputGraph[i].get(j).getReverseWeight();
			}
			if (sum != 0)
				for(int j=0; j<size_i; j++){
					InputGraph[i].get(j).divUpdateRWeight(sum);
					int neighbor = InputGraph[i].get(j).getNeighbor();
					int index = FindIndex(InputGraph[neighbor], i);
					InputGraph[neighbor].get(index).setWeight(InputGraph[i].get(j).getReverseWeight());
				}
		}

		
		return InputGraph;
	}
	public static int FindIndex(ArrayList container, int searchneighbor){
		int size = container.size();
		for (int i=0; i<size; i++){
			int neighbor = ((LinkNode)container.get(i)).getNeighbor();
			if (neighbor == searchneighbor) return i;
		}
		return -1;
	}
	
	public static void writeEdges_2_file(String file, ArrayList<weightedEdge>[] edges) throws IOException{
		DataOutputStream outfile = new DataOutputStream(new FileOutputStream(file));
		int len = edges.length;
		outfile.writeInt(len);						//size of list (number of nodes)
		for(int i =0; i<len; i++){
			int size = edges[i].size();
			outfile.writeInt(size);
			for(int j=0; j<size; j++){
				weightedEdge member = edges[i].get(j);
				outfile.writeInt(member.getNeighbor());
				outfile.writeFloat(member.getWeight());
				outfile.writeFloat(member.getReverseWeight());
			}
		}
		outfile.flush();
		outfile.close();
		
	}
	public static void writeMClusters_2_file(String file, ArrayList<Integer>[] MClusters) throws IOException{
		DataOutputStream outfile = new DataOutputStream(new FileOutputStream(file));
		int len = MClusters.length;
		outfile.writeInt(len);						//size of list (number of nodes)
		for(int i =0; i<len; i++){
			int size = MClusters[i].size();
			outfile.writeInt(size);
			for(int j=0; j<size; j++){
				outfile.writeInt(MClusters[i].get(j));
			}
		}
		outfile.flush();
		outfile.close();
	}
	public static ArrayList<weightedEdge>[] readEdges_from_file(String file, Hashtable<HTNode, Integer> HTGraph) throws IOException{
		DataInputStream infile = new DataInputStream(new FileInputStream(file));
		int len = infile.readInt();
		ArrayList<weightedEdge>[] edges = new ArrayList[len];
		for (int i =0; i<len; i++){
			edges[i] = new ArrayList<weightedEdge>();
			int size = infile.readInt();
			for (int j=0; j<size; j++){
				int neighbor = infile.readInt();
				float weight = infile.readFloat();
				float rWeight = infile.readFloat();
				int Index = edges[i].size();
				edges[i].add(new weightedEdge(neighbor, weight, rWeight));
				HTGraph.put(new HTNode(new int[]{i,neighbor}), Index);
			}
		}
		infile.close();
		return edges;
	}
	public static ArrayList<weightedEdge>[] cut_edges(ArrayList<weightedEdge>[] edges)throws IOException{
		int cutsize = 50000;
		int linkNum = 0;
		ArrayList<weightedEdge>[] cutted_edges = new ArrayList[cutsize];
		for(int i=0; i<cutsize; i++){
			cutted_edges[i] = new ArrayList<weightedEdge>();
			int realNeighborsSize = edges[i].size();
			for(int j=0; j<realNeighborsSize; j++){
				if(edges[i].get(j).getNeighbor()<cutsize){
					linkNum++;
					cutted_edges[i].add(new weightedEdge(edges[i].get(j).getNeighbor(), edges[i].get(j).getWeight(), edges[i].get(j).getReverseWeight()));
				}
			}
		}
		System.out.println("Number of Links between the first "+cutsize+" nodes is: "+linkNum);
		return cutted_edges;
	}
	public static ArrayList<Integer>[] readMClusters_from_file(String file) throws IOException{
		DataInputStream infile = new DataInputStream(new FileInputStream(file));
		int len = infile.readInt();
		ArrayList<Integer>[] MClusters = new ArrayList[len];
		for (int i =0; i<len; i++){
			MClusters[i] = new ArrayList<Integer>();
			int size = infile.readInt();
			for (int j=0; j<size; j++){
				MClusters[i].add(infile.readInt());
			}
		}
		infile.close();
		return MClusters;
	}
}
